/*
 * crypto/testing/test_blowfish.c
 *
 * Written by Raimar Falke <rf13@inf.tu-dresden.de> 1998-12-17
 * Copied from speed.c.
 *
 * Copyright 1998 by Raimar Falke. Redistribution of this file
 * is permitted under the GNU Public License.
 */

#define __KERNEL__

#define printk printk_dummy

#include <linux/crypto.h>

#undef memcpy
#undef memset
#undef printk

#include "libcfuncs.h"
#include "misc.h"

#define u32 unsigned int

int main()
{
	struct cipher_implementation *ci;
	struct cipher_context *cx;

	unsigned char key1[]={0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00};
	u32 input1[2]={0x00000000, 0x00000000};
	u32 output1[2];

	/* Register all ciphers */
	cryptoapi_init();
	
	ci = find_cipher_by_id(CIPHER_BLOWFISH);
	if (!ci)
	{
		PRINTF("Can't find blowfish\n");
		return 1;
	}

	cx = (struct cipher_context *) malloc(sizeof(struct cipher_context));
	cx->ci = ci;
	cx->keyinfo = (u32 *) malloc(ci->key_schedule_size);
	ci->set_key(cx, key1, sizeof(key1));

	ci->encrypt(cx,(u8 *)input1,(u8 *)output1,8);
	dump_u32_buffer(output1,8);

	ci->decrypt(cx,(u8 *)output1,(u8 *)input1,8);
	dump_u32_buffer(input1,8);

	return 0;
}

