
/*
 * NOTE:  You must include i2obscsi.h before including this file
 */

/*
 *      SCSI opcodes
 */
/*
 * i2oscsi2dixkxfer is a table of data transfer direction for SCSI Disk 
 * device commands.  The table indicates if the command will transfer 
 * data in (from device to system) or data out (from system to device)
 * NOSUPPORT indicates the command is not used for a disk device
 */

/* #define	DATAIN	I2O_SCB_FLAG_XFER_FROM_DEVICE */
#define	DATAIN	0x01
/* #define	DATAOUT	I2O_SCB_FLAG_XFER_TO_DEVICE */
#define	DATAOUT	0x02
/* #define	NODATA	I2O_SCB_FLAG_NO_DATA_XFER */
#define	NODATA	0x00
#define	NOSUPPORT	0xFF

unsigned char i2oscsi2diskxfer[] = {


/* TEST_UNIT_READY       0x00 */ NODATA,
/* REZERO_UNIT           0x01 */ NODATA,
/*			 0x02 */ NOSUPPORT,
/* REQUEST_SENSE         0x03 */ DATAIN,
/* FORMAT_UNIT           0x04 */ DATAOUT,
/* READ_BLOCK_LIMITS     0x05 */ DATAIN,
/*			 0x06 */ NOSUPPORT,
/* REASSIGN_BLOCKS       0x07 */ DATAOUT,
/* READ_6                0x08 */ DATAIN,

/*			 0x09 */ NOSUPPORT,

/* WRITE_6               0x0a */ DATAOUT,
/* SEEK_6                0x0b */ NODATA,
/*			 0x0c */ NOSUPPORT,
/*			 0x0d */ NOSUPPORT,
/*			 0x0e */ NOSUPPORT,
/* READ_REVERSE          0x0f */ NOSUPPORT,
/* WRITE_FILEMARKS       0x10 */ NODATA,
/* SPACE                 0x11 */ NOSUPPORT,
/* INQUIRY               0x12 */ DATAIN,
/*			 0x13 */ NOSUPPORT,
/* RECOVER_BUFFERED_DATA 0x14 */ NOSUPPORT,
/* MODE_SELECT           0x15 */ DATAOUT,
/* RESERVE               0x16 */ DATAOUT,
/* RELEASE               0x17 */ NODATA,
/* COPY                  0x18 */ DATAOUT,
	/* ERASE                 0x19 */ NOSUPPORT,
	/* NODATA if supported */
/* MODE_SENSE            0x1a */ DATAIN,
/* START_STOP            0x1b */ NODATA,
/* RECEIVE_DIAGNOSTIC    0x1c */ DATAIN,
/* SEND_DIAGNOSTIC       0x1d */ DATAOUT,
/* ALLOW_MEDIUM_REMOVAL  0x1e */ NODATA,

/*			 0x1f */ NOSUPPORT,
/*			 0x20 */ NOSUPPORT,
/*			 0x21 */ NOSUPPORT,
/*			 0x22 */ NOSUPPORT,
/*			 0x23 */ NOSUPPORT,

/* SET_WINDOW            0x24 */ DATAOUT,
/* READ_CAPACITY         0x25 */ DATAIN,

/*			 0x26 */ NOSUPPORT,
/*			 0x27 */ NOSUPPORT,

/* READ_10               0x28 */ DATAIN,

/*			 0x29 */ NOSUPPORT,

/* WRITE_10              0x2a */ DATAOUT,
/* SEEK_10               0x2b */ NODATA,

/*			 0x2c */ NOSUPPORT,
/*			 0x2d */ NOSUPPORT,

/* WRITE_VERIFY          0x2e */ DATAOUT,
/* VERIFY                0x2f */ NODATA,
/* SEARCH_HIGH           0x30 */ DATAOUT,
/* SEARCH_EQUAL          0x31 */ DATAOUT,
/* SEARCH_LOW            0x32 */ DATAOUT,
/* SET_LIMITS            0x33 */ NODATA,
/* PRE_FETCH             0x34 */ DATAIN,
/* SYNCHRONIZE_CACHE     0x35 */ NODATA,
/* LOCK_UNLOCK_CACHE     0x36 */ NODATA,
/* READ_DEFECT_DATA      0x37 */ DATAIN,
/* MEDIUM_SCAN           0x38 */ DATAOUT,
/* COMPARE               0x39 */ DATAOUT,
/* COPY_VERIFY           0x3a */ DATAOUT,
/* WRITE_BUFFER          0x3b */ DATAOUT,
/* READ_BUFFER           0x3c */ DATAIN,
/* UPDATE_BLOCK          0x3d */ DATAOUT,
/* READ_LONG             0x3e */ DATAIN,
/* WRITE_LONG            0x3f */ DATAOUT,
/* CHANGE_DEFINITION     0x40 */ DATAOUT,
/* WRITE_SAME            0x41 */ DATAOUT,

/*			 0x42 */ DATAIN,

/* READ_TOC              0x43 */ DATAIN,

/*			 0x44 */ DATAIN,
/*			 0x45 */ NOSUPPORT,
/*			 0x46 */ NOSUPPORT,
/*			 0x47 */ NOSUPPORT,
/*			 0x48 */ NOSUPPORT,
/*			 0x49 */ NOSUPPORT,
/*			 0x4a */ NOSUPPORT,
/*			 0x4b */ NOSUPPORT,

/* LOG_SELECT            0x4c */ DATAOUT,
/* LOG_SENSE             0x4d */ DATAIN,

/*			 0x4e */ NOSUPPORT,
/*			 0x4f */ NOSUPPORT,
/*			 0x50 */ NOSUPPORT,
/*			 0x51 */ DATAIN,
/*			 0x52 */ DATAIN,
/*			 0x53 */ DATAOUT,
/*			 0x54 */ NOSUPPORT,

/* MODE_SELECT_10        0x55 */ DATAOUT,

/*			 0x56 */ NODATA,
/*			 0x57 */ NODATA,
/*			 0x58 */ NOSUPPORT,
/*			 0x59 */ NOSUPPORT,

/* MODE_SENSE_10         0x5a */ DATAIN,

/*			 0x5b */ DATAIN,
/*			 0x5c */ DATAIN,
/*			 0x5d */ NOSUPPORT,
/*			 0x5e */ NOSUPPORT,
/*			 0x5f */ NOSUPPORT,

/* assign NOSUPPORT for 0x60 - 0x9f */
	/* 0x60 - 0x6f */
	NOSUPPORT, NOSUPPORT, NOSUPPORT, NOSUPPORT, NOSUPPORT, NOSUPPORT,
	NOSUPPORT, NOSUPPORT,
	NOSUPPORT, NOSUPPORT, NOSUPPORT, NOSUPPORT, NOSUPPORT, NOSUPPORT,
	NOSUPPORT, NOSUPPORT,
	/* 0x70 - 0x7f */
	NOSUPPORT, NOSUPPORT, NOSUPPORT, NOSUPPORT, NOSUPPORT, NOSUPPORT,
	NOSUPPORT, NOSUPPORT,
	NOSUPPORT, NOSUPPORT, NOSUPPORT, NOSUPPORT, NOSUPPORT, NOSUPPORT,
	NOSUPPORT, NOSUPPORT,
	/* 0x80 - 0x8f */
	NOSUPPORT, NOSUPPORT, NOSUPPORT, NOSUPPORT, NOSUPPORT, NOSUPPORT,
	NOSUPPORT, NOSUPPORT,
	NOSUPPORT, NOSUPPORT, NOSUPPORT, NOSUPPORT, NOSUPPORT, NOSUPPORT,
	NOSUPPORT, NOSUPPORT,
	/* 0x90 - 0x9f */
	NOSUPPORT, NOSUPPORT, NOSUPPORT, NOSUPPORT, NOSUPPORT, NOSUPPORT,
	NOSUPPORT, NOSUPPORT,
	NOSUPPORT, NOSUPPORT, NOSUPPORT, NOSUPPORT, NOSUPPORT, NOSUPPORT,
	NOSUPPORT, NOSUPPORT,

/*			 0xa0 */ NOSUPPORT,
/*			 0xa1 */ NOSUPPORT,
/*			 0xa2 */ NOSUPPORT,
/*			 0xa3 */ NOSUPPORT,
/*			 0xa4 */ NOSUPPORT,

/* MOVE_MEDIUM           0xa5 */ NODATA,

/*			 0xa6 */ NOSUPPORT,
/*			 0xa7 */ NOSUPPORT,

/* READ_12               0xa8 */ DATAIN,

/*			 0xa9 */ NOSUPPORT,

/* WRITE_12              0xaa */ DATAOUT,

/*			 0xab */ NOSUPPORT,
/*			 0xac */ NOSUPPORT,
/*			 0xad */ NOSUPPORT,

/* WRITE_VERIFY_12       0xae */ DATAOUT,

/*			 0xaf */ NOSUPPORT,

/* SEARCH_HIGH_12        0xb0 */ DATAOUT,
/* SEARCH_EQUAL_12       0xb1 */ DATAOUT,
/* SEARCH_LOW_12         0xb2 */ DATAOUT,

/*			 0xb3 */ NOSUPPORT,
/*			 0xb4 */ NOSUPPORT,
/*			 0xb5 */ NOSUPPORT,

/* SEND_VOLUME_TAG       0xb6 */ DATAOUT,

/*			 0xb7 */ NOSUPPORT,

/* READ_ELEMENT_STATUS   0xb8 */ DATAIN,

/*			 0xb9 */ NOSUPPORT,
/*			 0xba */ NOSUPPORT,
/*			 0xbb */ DATAOUT,
/*			 0xbc */ NOSUPPORT,
/*			 0xbd */ DATAIN,
/*			 0xbe */ NOSUPPORT,
/*			 0xbf */ NOSUPPORT,

/* assign NOSUPPORT for 0xc0 - 0xdf */
	/* 0xc0 - 0xcf */
	NOSUPPORT, NOSUPPORT, NOSUPPORT, NOSUPPORT, NOSUPPORT, NOSUPPORT,
	NOSUPPORT, NOSUPPORT,
	NOSUPPORT, NOSUPPORT, NOSUPPORT, NOSUPPORT, NOSUPPORT, NOSUPPORT,
	NOSUPPORT, NOSUPPORT,
	/* 0xd0 - 0xdf */
	NOSUPPORT, NOSUPPORT, NOSUPPORT, NOSUPPORT, NOSUPPORT, NOSUPPORT,
	NOSUPPORT, NOSUPPORT,
	NOSUPPORT, NOSUPPORT, NOSUPPORT, NOSUPPORT, NOSUPPORT, NOSUPPORT,
	NOSUPPORT, NOSUPPORT,

/*			 0xe0 */ NOSUPPORT,
/*			 0xe1 */ NOSUPPORT,
/*			 0xe2 */ NOSUPPORT,
/*			 0xe3 */ NOSUPPORT,
/*			 0xe4 */ NOSUPPORT,
/*			 0xe5 */ NOSUPPORT,
/*			 0xe6 */ NOSUPPORT,
/*			 0xe7 */ NOSUPPORT,
/*			 0xe8 */ NOSUPPORT,
/*			 0xe9 */ NOSUPPORT,

/* WRITE_LONG_2          0xea */ DATAOUT
};

#define	DISKXFERTBLSIZE sizeof(i2oscsi2diskxfer)
