/*
 *	Generic parts
 *	Linux ethernet bridge
 *
 *	Authors:
 *	Lennert Buytenhek		<buytenh@gnu.org>
 *
 *	$Id$
 *
 *	This program is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU General Public License
 *	as published by the Free Software Foundation; either version
 *	2 of the License, or (at your option) any later version.
 */

#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/miscdevice.h>
#include <linux/netdevice.h>
#include <linux/etherdevice.h>
#include <linux/init.h>
#include <linux/if_bridge.h>
#include <asm/uaccess.h>
#include "br_private.h"

void br_dec_use_count()
{
	MOD_DEC_USE_COUNT;
}

void br_inc_use_count()
{
	MOD_INC_USE_COUNT;
}

__initfunc(int br_init(void))
{
	printk(KERN_INFO "NET4: Ethernet Bridge 008 for NET4.0\n");

	br_handle_frame_hook = br_handle_frame;
	br_ioctl_hook = br_ioctl_deviceless_stub;
	register_netdevice_notifier(&br_device_notifier);

	return brfw_init();
}

#ifdef CONFIG_BRIDGE_MODULE
EXPORT_NO_SYMBOLS;

int init_module(void)
{
	return br_init();
}

void cleanup_module(void)
{
	brfw_uninit();
	unregister_netdevice_notifier(&br_device_notifier);
	br_ioctl_hook = NULL;
	br_handle_frame_hook = NULL;
	synchronize_bh();
}

#endif
